"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var PaginationDirection_1 = require("@js-entity-repos/core/dist/types/PaginationDirection");
var SortOrder_1 = require("@js-entity-repos/core/dist/types/SortOrder");
var createGetEntitiesResult_1 = require("@js-entity-repos/core/dist/utils/createGetEntitiesResult");
var createPaginationFilter_1 = require("@js-entity-repos/core/dist/utils/createPaginationFilter");
var lodash_1 = require("lodash");
var constructMongoFilter_1 = require("../utils/constructMongoFilter");
var xor = function (conditionA, conditionB) {
    return (conditionA && !conditionB) || (!conditionA && conditionB);
};
exports.default = (function (config) {
    var defaultPagination = {
        cursor: undefined,
        direction: PaginationDirection_1.forward,
        limit: config.defaultPaginationLimit,
    };
    var defaultSort = { id: SortOrder_1.asc };
    return function (_a) {
        var _b = _a.filter, filter = _b === void 0 ? {} : _b, _c = _a.sort, sort = _c === void 0 ? defaultSort : _c, _d = _a.pagination, pagination = _d === void 0 ? defaultPagination : _d;
        return __awaiter(_this, void 0, void 0, function () {
            var db, collection, paginationFilter, fullFilter, constructedFilter, constructedSort, mongoFilter, mongoSort, results, documents, entities, isEnd;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0: return [4 /*yield*/, config.db()];
                    case 1:
                        db = (_e.sent());
                        collection = db.collection(config.collectionName);
                        paginationFilter = createPaginationFilter_1.default(pagination, sort);
                        fullFilter = { $and: [filter, paginationFilter] };
                        constructedFilter = config.constructFilter(fullFilter);
                        constructedSort = config.constructSort(sort);
                        mongoFilter = constructMongoFilter_1.default(constructedFilter);
                        mongoSort = lodash_1.mapValues(constructedSort, function (sortOrder) {
                            return !xor(pagination.direction === PaginationDirection_1.forward, sortOrder === SortOrder_1.asc) ? 1 : -1;
                        });
                        return [4 /*yield*/, collection
                                .find(mongoFilter)
                                .sort(mongoSort)
                                .limit(pagination.limit + 1)
                                .toArray()];
                    case 2:
                        results = _e.sent();
                        documents = results.slice(0, pagination.limit);
                        entities = documents.map(config.constructEntity);
                        isEnd = results.length <= pagination.limit;
                        return [2 /*return*/, createGetEntitiesResult_1.default({ entities: entities, isEnd: isEnd, pagination: pagination, sort: sort })];
                }
            });
        });
    };
});
//# sourceMappingURL=getEntities.js.map